searchNodes=[{"doc":"Behaviour for creating Bamboo adaptersAll recipients in the Bamboo.Email struct will be normalized to a two item tuple of {name, address} when delivered through your mailer. For example, elem(email.from, 0) would return the name and elem(email.from, 1) would return the email address.For more in-depth examples check out the adapters in Bamboo.Exampledefmodule Bamboo.CustomAdapter do @behaviour Bamboo.Adapter def deliver(email, config) do deliver_the_email_somehow(email) end def handle_config(config) do # Return the config if nothing special is required config # Or you could require certain config options if Map.get(config, :smtp_username) do config else raise &quot;smtp_username is required in config, got \#{inspect(config)}&quot; end end def supports_attachments?, do: true end","ref":"Bamboo.Adapter.html","title":"Bamboo.Adapter","type":"behaviour"},{"doc":"","ref":"Bamboo.Adapter.html#c:deliver/2","title":"Bamboo.Adapter.deliver/2","type":"callback"},{"doc":"","ref":"Bamboo.Adapter.html#c:handle_config/1","title":"Bamboo.Adapter.handle_config/1","type":"callback"},{"doc":"","ref":"Bamboo.Adapter.html#c:supports_attachments?/0","title":"Bamboo.Adapter.supports_attachments?/0","type":"callback"},{"doc":"","ref":"Bamboo.AdapterHelper.html","title":"Bamboo.AdapterHelper","type":"module"},{"doc":"","ref":"Bamboo.AdapterHelper.html#hackney_opts/1","title":"Bamboo.AdapterHelper.hackney_opts/1","type":"function"},{"doc":"","ref":"Bamboo.Attachment.html","title":"Bamboo.Attachment","type":"module"},{"doc":"Creates a new Attachmentcontent_id can be used to embed an image, attach it and reference it in the message body by setting its CID (Content-ID) and using a standard HTML tag:&lt;img src=&quot;cid:some-image-cid&quot; alt=&quot;img&quot; /&gt;within an HTML email message.Examples:Bamboo.Attachment.new(&quot;/path/to/attachment.png&quot;) Bamboo.Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;) Bamboo.Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;, content_type: &quot;image/png&quot;, content_id: &quot;12387432&quot;) Bamboo.Attachment.new(params[&quot;file&quot;]) # Where params[&quot;file&quot;] is a %Plug.Upload email |&gt; put_html_layout({LayoutView, &quot;email.html&quot;}) |&gt; put_attachment(%Bamboo.Attachment{content_type: &quot;image/png&quot;, filename: &quot;logo.png&quot;, data: &quot;content&quot;, content_id: &quot;2343333333&quot;})","ref":"Bamboo.Attachment.html#new/2","title":"Bamboo.Attachment.new/2","type":"function"},{"doc":"","ref":"Bamboo.Attachment.html#t:t/0","title":"Bamboo.Attachment.t/0","type":"type"},{"doc":"Behaviour for delivering emails with Bamboo.Mailer.deliver_later/1.Use this behaviour to create strategies for background email delivery. You could make a strategy using a GenServer, a background job library or whatever else you decide.Bamboo ships with two strategies:Bamboo.TaskSupervisorStrategyBamboo.ImmediateDeliveryStrategyExample of setting custom strategiesconfig :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapter, # or whatever adapter you want deliver_later_strategy: MyCustomStrategyExample of creating a custom strategy for delivering later using Task.asyncdefmodule Bamboo.TaskAsyncStrategy do @behaviour Bamboo.DeliverLaterStrategy # This is a strategy for delivering later using Task.async def deliver_later(adapter, email, config) do Task.async fn -&gt; # Always call deliver on the adapter so that the email is delivered. adapter.deliver(email, config) end end end","ref":"Bamboo.DeliverLaterStrategy.html","title":"Bamboo.DeliverLaterStrategy","type":"behaviour"},{"doc":"","ref":"Bamboo.DeliverLaterStrategy.html#c:deliver_later/3","title":"Bamboo.DeliverLaterStrategy.deliver_later/3","type":"callback"},{"doc":"Contains functions for composing emails.Bamboo separates composing emails from delivering them. This separation makes emails easy to test and makes things like using a default layout or a default from address easy to do. This module is for creating emails. To actually send them, use Bamboo.Mailer.Handling email addressesThe from, to, cc, and bcc addresses of a Bamboo.Email can be set to any data structure for which there is an implementation of the Bamboo.Formatter protocol or a list of such data structures. Bamboo includes implementations for some common data structures or you can create your own. All from, to, cc, and bcc addresses are normalized internally to a two item tuple of {name, address}. See Bamboo.Formatter for more info.Simplest way to create a new emaildefmodule MyApp.Email do import Bamboo.Email def welcome_email(user) do new_email( from: &quot;me@app.com&quot;, to: user, subject: &quot;Welcome!&quot;, text_body: &quot;Welcome to the app&quot;, html_body: &quot;&lt;strong&gt;Welcome to the app&lt;/strong&gt;&quot; ) end endExtracting common parts (default layout, default from address, etc.)Let's say you want all emails to have the same from address. Here's how you could do thatdefmodule MyApp.Email do import Bamboo.Email def welcome_email(user) do # Since new_email/1 returns a struct you can update it with Kernel.struct!/2 struct!(base_email(), to: user, subject: &quot;Welcome!&quot;, text_body: &quot;Welcome to the app&quot;, html_body: &quot;&lt;strong&gt;Welcome to the app&lt;/strong&gt;&quot; ) end def base_email do new_email(from: &quot;me@app.com&quot;) end endIn addition to keyword lists, Bamboo.Emails can also be built using function pipelines.defmodule MyApp.Email do import Bamboo.Email def welcome_email(user) do base_email() |&gt; to(user) |&gt; subject(&quot;Welcome!&quot;) |&gt; text_body(&quot;Welcome to the app&quot;) |&gt; html_body(&quot;&lt;strong&gt;Welcome to the app&lt;/strong&gt;&quot;) end end","ref":"Bamboo.Email.html","title":"Bamboo.Email","type":"module"},{"doc":"Returns a list of all recipients (to, cc and bcc).","ref":"Bamboo.Email.html#all_recipients/1","title":"Bamboo.Email.all_recipients/1","type":"function"},{"doc":"Sets the bcc on the email.bcc receives as an argument any data structure for which there is an implementation of the Bamboo.Formatter protocol.new_email() |&gt; bcc([&quot;sally@example.com&quot;, &quot;james@example.com&quot;])","ref":"Bamboo.Email.html#bcc/2","title":"Bamboo.Email.bcc/2","type":"function"},{"doc":"Sets the cc on the email.cc receives as an argument any data structure for which there is an implementation of the Bamboo.Formatter protocol.new_email() |&gt; cc([&quot;sally@example.com&quot;, &quot;james@example.com&quot;])","ref":"Bamboo.Email.html#cc/2","title":"Bamboo.Email.cc/2","type":"function"},{"doc":"Sets the from on the email.from receives as an argument any data structure for which there is an implementation of the Bamboo.Formatter protocol.new_email() |&gt; from([&quot;sally@example.com&quot;, &quot;james@example.com&quot;])","ref":"Bamboo.Email.html#from/2","title":"Bamboo.Email.from/2","type":"function"},{"doc":"Gets just the email address from a normalized email addressNormalized email addresses are 2 item tuples {name, address}. This gets the address part of the tuple. Use this instead of calling elem(address, 1) so that if Bamboo changes how email addresses are represented your code will still workExamplesBamboo.Email.get_address({&quot;Paul&quot;, &quot;paul@thoughtbot.com&quot;}) # &quot;paul@thoughtbot.com&quot;","ref":"Bamboo.Email.html#get_address/1","title":"Bamboo.Email.get_address/1","type":"function"},{"doc":"Sets the html_body on the email","ref":"Bamboo.Email.html#html_body/2","title":"Bamboo.Email.html_body/2","type":"function"},{"doc":"Used to create a new emailIf called without arguments it is the same as creating an empty %Bamboo.Email{} struct. If called with arguments it will populate the struct with given attributes.Example# Same as %Bamboo.Email{from: &quot;support@myapp.com&quot;} new_email(from: &quot;support@myapp.com&quot;)","ref":"Bamboo.Email.html#new_email/1","title":"Bamboo.Email.new_email/1","type":"function"},{"doc":"Adds a data attachment to the emailExampleput_attachment(email, %Bamboo.Attachment{})Requires the fields filename and data of the %Bamboo.Attachment{} struct to be set.Exampledef create(conn, params) do #... email |&gt; put_attachment(%Bamboo.Attachment{filename: &quot;event.ics&quot;, data: &quot;BEGIN:VCALENDAR...&quot;}) #... end","ref":"Bamboo.Email.html#put_attachment/2","title":"Bamboo.Email.put_attachment/2","type":"function"},{"doc":"Adds a file attachment to the emailExampleput_attachment(email, path, opts \\\\ [])Accepts filename: &lt;name&gt; and content_type: &lt;type&gt; options.If you are using Plug, it accepts a Plug.Upload structExampledef create(conn, params) do #... email |&gt; put_attachment(params[&quot;file&quot;]) #... end","ref":"Bamboo.Email.html#put_attachment/3","title":"Bamboo.Email.put_attachment/3","type":"function"},{"doc":"Adds a header to the emailExampleput_header(email, &quot;Reply-To&quot;, &quot;support@myapp.com&quot;)","ref":"Bamboo.Email.html#put_header/3","title":"Bamboo.Email.put_header/3","type":"function"},{"doc":"Adds a key/value to the private key of the emailThis is mostly used to implement specific functionality for a particular adapter. It will rarely be used directly from your code. Internally this is used to set Mandrill specific params for the MandrillAdapter and it's also used to store the view module, template and layout when using Bamboo.Phoenix.Exampleput_private(email, :tags, &quot;welcome-email&quot;)","ref":"Bamboo.Email.html#put_private/3","title":"Bamboo.Email.put_private/3","type":"function"},{"doc":"Sets the subject on the email","ref":"Bamboo.Email.html#subject/2","title":"Bamboo.Email.subject/2","type":"function"},{"doc":"Sets the text_body on the email","ref":"Bamboo.Email.html#text_body/2","title":"Bamboo.Email.text_body/2","type":"function"},{"doc":"Sets the to on the email.to receives as an argument any data structure for which there is an implementation of the Bamboo.Formatter protocol.new_email() |&gt; to([&quot;sally@example.com&quot;, &quot;james@example.com&quot;])","ref":"Bamboo.Email.html#to/2","title":"Bamboo.Email.to/2","type":"function"},{"doc":"","ref":"Bamboo.Email.html#t:address/0","title":"Bamboo.Email.address/0","type":"type"},{"doc":"","ref":"Bamboo.Email.html#t:address_list/0","title":"Bamboo.Email.address_list/0","type":"type"},{"doc":"","ref":"Bamboo.Email.html#t:t/0","title":"Bamboo.Email.t/0","type":"type"},{"doc":"Converts data to email addresses.Implementations of the Bamboo.Formatter protocol convert a given data structure to a two item tuple of {name, address} or an address string. The opts argument is a map with the key :type and a value of :from, :to, :cc, or :bcc. The options argument allows functions to pattern match an address type and format a given data structure differently for different types of addresses.Simple exampleLet's say you have a user struct like this.defmodule MyApp.User do defstruct first_name: nil, last_name: nil, email: nil endBamboo can automatically format this struct if you implement the Bamboo.Formatter protocol.defimpl Bamboo.Formatter, for: MyApp.User do # Used by `to`, `bcc`, `cc` and `from` def format_email_address(user, _opts) do fullname = &quot;\#{user.first_name} \#{user.last_name}&quot; {fullname, user.email} end endNow you can create emails like this, and the user will be formatted correctlyuser = %User{first_name: &quot;John&quot;, last_name: &quot;Doe&quot;, email: &quot;me@example.com&quot;} Bamboo.Email.new_email(from: user)Customize formatting based on from, to, cc or bccBy pattern matching the opts argument, you can format a given data structure differently for different types of addresses. For example, if you want to provide the name of the app when sending email on behalf of a user, you can format the name for all type: :from addresses.defimpl Bamboo.Formatter, for: MyApp.User do # Include the app name when used in a from address def format_email_address(user, %{type: :from}) do fullname = &quot;\#{user.first_name} \#{user.last_name}&quot; {fullname &lt;&gt; &quot; (Sent from MyApp)&quot;, user.email} end # Just use the name for all other types def format_email_address(user, _opts) do fullname = &quot;\#{user.first_name} \#{user.last_name}&quot; {fullname, user.email} end end","ref":"Bamboo.Formatter.html","title":"Bamboo.Formatter","type":"protocol"},{"doc":"Receives data and opts and returns a string or a two item tuple {name, address}opts is a map with the key :type and a value of :from, :to, :cc or :bcc. You can pattern match on this to customize the address.","ref":"Bamboo.Formatter.html#format_email_address/2","title":"Bamboo.Formatter.format_email_address/2","type":"function"},{"doc":"","ref":"Bamboo.Formatter.html#t:opts/0","title":"Bamboo.Formatter.opts/0","type":"type"},{"doc":"","ref":"Bamboo.Formatter.html#t:t/0","title":"Bamboo.Formatter.t/0","type":"type"},{"doc":"Strategy for Bamboo.Mailer.deliver_later/1 that sends the email immediately.This strategy is used and required by the Bamboo.LocalAdapter and Bamboo.TestAdapter.","ref":"Bamboo.ImmediateDeliveryStrategy.html","title":"Bamboo.ImmediateDeliveryStrategy","type":"module"},{"doc":"Stores emails locally. Can be queried to see sent emails.Use this adapter for storing emails locally instead of sending them. Emails are stored and can be read from Bamboo.SentEmail. Typically this adapter is used in the dev environment so emails are not delivered to real email addresses.You can use this adapter along with Bamboo.SentEmailViewerPlug to view emails in the browser.If you want to open a new browser window for every new email, set the option open_email_in_browser_url to your preview path.Example config# In config/config.exs, or config/dev.exs, etc. config :my_app, MyApp.Mailer, adapter: Bamboo.LocalAdapter, open_email_in_browser_url: &quot;http://localhost:4000/sent_emails&quot; # optional # Define a Mailer. Maybe in lib/my_app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app end","ref":"Bamboo.LocalAdapter.html","title":"Bamboo.LocalAdapter","type":"module"},{"doc":"Adds email to Bamboo.SentEmail, can automatically open it in new browser tab","ref":"Bamboo.LocalAdapter.html#deliver/2","title":"Bamboo.LocalAdapter.deliver/2","type":"function"},{"doc":"Callback implementation for Bamboo.Adapter.handle_config/1.","ref":"Bamboo.LocalAdapter.html#handle_config/1","title":"Bamboo.LocalAdapter.handle_config/1","type":"function"},{"doc":"Callback implementation for Bamboo.Adapter.supports_attachments?/0.","ref":"Bamboo.LocalAdapter.html#supports_attachments?/0","title":"Bamboo.LocalAdapter.supports_attachments?/0","type":"function"},{"doc":"Functions for delivering emails using adapters and delivery strategies.Adds deliver_now/1 and deliver_later/1 functions to the mailer module it is used by.Bamboo ships with several adapters. It is also possible to create your own adapter.See the &quot;Getting Started&quot; section of the README for an example of how to set up and configure a mailer for use.ExampleCreating a Mailer is as simple as defining a module in your application and using the Bamboo.Mailer.# some/path/within/your/app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app endThe mailer requires some configuration within your application.# config/config.exs config :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapter, # Specify your preferred adapter api_key: &quot;my_api_key&quot; # Specify adapter-specific configurationAlso you will want to define an email module for building email structs that your mailer can send. See [Bamboo.Email] for more information.# some/path/within/your/app/email.ex defmodule MyApp.Email do import Bamboo.Email def welcome_email do new_email( to: &quot;john@example.com&quot;, from: &quot;support@myapp.com&quot;, subject: &quot;Welcome to the app.&quot;, html_body: &quot;&lt;strong&gt;Thanks for joining!&lt;/strong&gt;&quot;, text_body: &quot;Thanks for joining!&quot; ) end endYou are now able to send emails with your mailer module where you sit fit within your application.","ref":"Bamboo.Mailer.html","title":"Bamboo.Mailer","type":"module"},{"doc":"","ref":"Bamboo.Mailer.html#build_config/3","title":"Bamboo.Mailer.build_config/3","type":"function"},{"doc":"Deliver an email in the background.Call your mailer with deliver_later/1 to send an email using the configured deliver_later_strategy. If no deliver_later_strategy is set, Bamboo.TaskSupervisorStrategy will be used. See Bamboo.DeliverLaterStrategy to learn how to change how emails are delivered with deliver_later/1.","ref":"Bamboo.Mailer.html#deliver_later/2","title":"Bamboo.Mailer.deliver_later/2","type":"function"},{"doc":"Deliver an email right away.Call your mailer with deliver_now/1 to send an email right away. Call deliver_later/1 if you want to send in the background.Pass in an argument of response: true if you need access to the response from delivering the email. This returns a tuple of the Email struct and the response from calling deliver with your adapter. This is useful if you need access to any data sent back from your email provider in the response.Email.welcome_email |&gt; Mailer.deliver_now(response: true)Pass in an argument of config: %{} if you would like to dynamically override any keys in your application's default Mailer configuration.Email.welcome_email |&gt; Mailer.deliver_now(config: %{username: &quot;Emma&quot;, smtp_port: 2525})","ref":"Bamboo.Mailer.html#deliver_now/2","title":"Bamboo.Mailer.deliver_now/2","type":"function"},{"doc":"Wraps to, cc and bcc addresses in a list and normalizes email addresses.Also formats the from address. Email normalization/formatting is done by implementations of the [Bamboo.Formatter] protocol.","ref":"Bamboo.Mailer.html#normalize_addresses/1","title":"Bamboo.Mailer.normalize_addresses/1","type":"function"},{"doc":"Sends email using Mailgun's API.Use this adapter to send emails through Mailgun's API. Requires that an API key and a domain are set in the config.See Bamboo.MailgunHelper for extra functions that can be used by Bamboo.MailgunAdapter (tagging, merge vars, etc.)Example config# In config/config.exs, or config.prod.exs, etc. config :my_app, MyApp.Mailer, adapter: Bamboo.MailgunAdapter, api_key: &quot;my_api_key&quot; # or {:system, &quot;MAILGUN_API_KEY&quot;}, domain: &quot;your.domain&quot; # or {:system, &quot;MAILGUN_DOMAIN&quot;}, hackney_opts: [ recv_timeout: :timer.minutes(1) ] # Define a Mailer. Maybe in lib/my_app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app endAPI base URI configurationMailgun makes a difference in the API base URL between sender domains from within the EU and outside.By default, the base URL is set to https://api.mailgun.net/v3. To override this globally, you can use the Application environment:Application.put_env(:bamboo, :mailgun_base_uri, &quot;https://api.eu.mailgun.net/v3&quot;)However, for advanced configurations (for instance, for multi-tenant setups where you pass in the adapter config when an email is sent), you might want to specify this on the adapter level:config :my_app, MyApp.Mailer, adapter: Bamboo.MailgunAdapter, api_key: &quot;my_api_key&quot;, domain: &quot;your.domain&quot;, base_uri: &quot;https://api.eu.mailgun.net/v3&quot;","ref":"Bamboo.MailgunAdapter.html","title":"Bamboo.MailgunAdapter","type":"module"},{"doc":"Callback implementation for Bamboo.Adapter.deliver/2.","ref":"Bamboo.MailgunAdapter.html#deliver/2","title":"Bamboo.MailgunAdapter.deliver/2","type":"function"},{"doc":"","ref":"Bamboo.MailgunAdapter.html#filter_non_empty_mailgun_fields/1","title":"Bamboo.MailgunAdapter.filter_non_empty_mailgun_fields/1","type":"function"},{"doc":"Functions for using features specific to Mailgun (e.g. tagging, templates).","ref":"Bamboo.MailgunHelper.html","title":"Bamboo.MailgunHelper","type":"module"},{"doc":"Schedule an email to be delivered in the future.More details can be found in the Mailgun documentationExampleone_hour_from_now = DateTime.utc_now() |&gt; DateTime.add(3600) email |&gt; MailgunHelper.deliverytime(one_hour_from_now)","ref":"Bamboo.MailgunHelper.html#deliverytime/2","title":"Bamboo.MailgunHelper.deliverytime/2","type":"function"},{"doc":"Adds Mailgun recipient variables to the outgoing emailMore details can be found in the Mailgun documentationExamplevariables = %{ &quot;user1@example.com&quot; =&gt; %{unique_id: &quot;ABC123456789&quot;}, &quot;user2@example.com&quot; =&gt; %{unique_id: &quot;ZXY987654321&quot;} } email |&gt; MailgunHelper.recipient_variables(variables)","ref":"Bamboo.MailgunHelper.html#recipient_variables/2","title":"Bamboo.MailgunHelper.recipient_variables/2","type":"function"},{"doc":"This behaves like Bamboo.MailgunHelper.substitute_variables/3, but accepts a Map rather than a key, value pair.Exampleemail |&gt; MailgunHelper.template(&quot;password-reset-email&quot;) |&gt; MailgunHelper.substitute_variables(%{ &quot;greeting&quot; =&gt; &quot;Hello!&quot;, &quot;password_reset_link&quot; =&gt; &quot;https://example.com/123&quot; })","ref":"Bamboo.MailgunHelper.html#substitute_variables/2","title":"Bamboo.MailgunHelper.substitute_variables/2","type":"function"},{"doc":"When sending an email with Bamboo.MailgunHelper.template/2 you can replace a handlebars variables using this function.More details about templates can be found in the Templates section of the Mailgun documentation.Exampleemail |&gt; MailgunHelper.template(&quot;password-reset-email&quot;) |&gt; MailgunHelper.substitute_variables(&quot;password_reset_link&quot;, &quot;https://example.com/123&quot;)","ref":"Bamboo.MailgunHelper.html#substitute_variables/3","title":"Bamboo.MailgunHelper.substitute_variables/3","type":"function"},{"doc":"Add a tag to outgoing email to help categorize traffic based on some criteria, perhaps separate signup emails from password recovery emails or from user comments.More details can be found in the Mailgun documentationExampleemail |&gt; MailgunHelper.tag(&quot;welcome-email&quot;)","ref":"Bamboo.MailgunHelper.html#tag/2","title":"Bamboo.MailgunHelper.tag/2","type":"function"},{"doc":"Send an email using a template stored in Mailgun, rather than supplying a Bamboo.Email.text_body/2 or a Bamboo.Email.html_body/2.More details about templates can be found in the Templates section of the Mailgun documentation.","ref":"Bamboo.MailgunHelper.html#template/2","title":"Bamboo.MailgunHelper.template/2","type":"function"},{"doc":"Use it if you want to have rendered template in the text part of the message in case of template sending.More details can be found in the Mailgun documentationExampleemail |&gt; MailgunHelper.template_text(true)","ref":"Bamboo.MailgunHelper.html#template_text/2","title":"Bamboo.MailgunHelper.template_text/2","type":"function"},{"doc":"Use it to send a message to specific version of a template.More details can be found in the Mailgun documentationExampleemail |&gt; MailgunHelper.template(&quot;my-template&quot;) |&gt; MailgunHelper.template_version(&quot;v2&quot;)","ref":"Bamboo.MailgunHelper.html#template_version/2","title":"Bamboo.MailgunHelper.template_version/2","type":"function"},{"doc":"Sends email using Mandrill's JSON API.Use this adapter to send emails through Mandrill's API. Requires that an API key is set in the config. See Bamboo.MandrillHelper for extra functions that can be used by Bamboo.MandrillAdapter (tagging, merge vars, etc.)Example config# In config/config.exs, or config/prod.exs, etc. config :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapter, api_key: &quot;my_api_key&quot;, hackney_opts: [ recv_timeout: :timer.minutes(1) ] # Define a Mailer. Maybe in lib/my_app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app end","ref":"Bamboo.MandrillAdapter.html","title":"Bamboo.MandrillAdapter","type":"module"},{"doc":"Callback implementation for Bamboo.Adapter.deliver/2.","ref":"Bamboo.MandrillAdapter.html#deliver/2","title":"Bamboo.MandrillAdapter.deliver/2","type":"function"},{"doc":"Functions for using features specific to Mandrill (e.g. tagging, merge vars, templates).","ref":"Bamboo.MandrillHelper.html","title":"Bamboo.MandrillHelper","type":"module"},{"doc":"Set merge_vars that are used by Mandrill.Exampleemail |&gt; put_merge_vars(users, fn(user) -&gt; %{first_name: user.first_name} end)A convenience function for:email |&gt; put_param(email, &quot;merge_vars&quot;, [ %{ rcpt: &quot;user1@example.com&quot;, vars: [ %{ &quot;name&quot;: &quot;full_name&quot;, &quot;content&quot;: &quot;User 1&quot; } ] }, %{ rcpt: &quot;user2@example.com&quot;, vars: [ %{ &quot;name&quot;: &quot;full_name&quot;, &quot;content&quot;: &quot;User 2&quot; } ] } ])","ref":"Bamboo.MandrillHelper.html#put_merge_vars/3","title":"Bamboo.MandrillHelper.put_merge_vars/3","type":"function"},{"doc":"Put extra message parameters that are used by Mandrill.Parameters set with this function are sent to Mandrill when used along with the Bamboo.MandrillAdapter. You can set things like important, merge_vars, and whatever else you need that the Mandrill API supports.Exampleemail |&gt; put_param(email, &quot;track_opens&quot;, true) |&gt; put_param(email, &quot;merge_vars&quot;, [ %{ rcpt: &quot;recipient.email@example.com&quot;, vars: [ %{ &quot;name&quot;: &quot;first_name&quot;, &quot;content&quot;: &quot;John Doe&quot; } ] } ])","ref":"Bamboo.MandrillHelper.html#put_param/3","title":"Bamboo.MandrillHelper.put_param/3","type":"function"},{"doc":"Set a single tag or multiple tags for an email.A convenience function for put_param(email, &quot;tags&quot;, [&quot;my-tag&quot;])Exampletag(email, &quot;welcome-email&quot;) tag(email, [&quot;welcome-email&quot;, &quot;marketing&quot;])","ref":"Bamboo.MandrillHelper.html#tag/2","title":"Bamboo.MandrillHelper.tag/2","type":"function"},{"doc":"Send emails using Mandrill's template API.Setup Mandrill to send using a named template with template content. Use this in conjunction with merge vars to offload template rendering to Mandrill. The template name specified here must match the template name stored in Mandrill. Mandrill's API docs for this can be found here.Exampletemplate(email, &quot;welcome&quot;) template(email, &quot;welcome&quot;, [%{&quot;name&quot; =&gt; &quot;Name&quot;, &quot;content&quot; =&gt; &quot;John&quot;}])","ref":"Bamboo.MandrillHelper.html#template/3","title":"Bamboo.MandrillHelper.template/3","type":"function"},{"doc":"Render emails with Phoenix templates and layouts.This module allows rendering emails with Phoenix layouts and views. Pass an atom (e.g. :welcome_email) as the template name to render both HTML and plain text emails. Use a string if you only want to render one type, e.g. &quot;welcome_email.text&quot; or &quot;welcome_email.html&quot;.ExamplesSet the text and HTML layout for an email.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def welcome_email do new_email() |&gt; put_text_layout({MyAppWeb.LayoutView, &quot;email.text&quot;}) |&gt; put_html_layout({MyAppWeb.LayoutView, &quot;email.html&quot;}) |&gt; render(:welcome) # Pass atom to render html AND plain text templates end endSet both the text and HTML layout at the same time for an email.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def welcome_email do new_email() |&gt; put_layout({MyAppWeb.LayoutView, :email}) |&gt; render(:welcome) end endRender both text and html emails without layouts.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def welcome_email do new_email() |&gt; render(:welcome) end endMake assigns available to a template.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def welcome_email(user) do new_email() |&gt; assign(:user, user) |&gt; render(:welcome) end endMake assigns available to a template during render call.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def welcome_email(user) do new_email() |&gt; put_html_layout({MyAppWeb.LayoutView, &quot;email.html&quot;}) |&gt; render(:welcome, user: user) end endRender an email by passing the template string to render.defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def html_email do new_email |&gt; render(&quot;html_email.html&quot;) end def text_email do new_email |&gt; render(&quot;text_email.text&quot;) end endHTML Layout Example# my_app_web/email.ex defmodule MyApp.Email do use Bamboo.Phoenix, view: MyAppWeb.EmailView def sign_in_email(person) do base_email() |&gt; to(person) |&gt; subject(&quot;Your Sign In Link&quot;) |&gt; assign(:person, person) |&gt; render(:sign_in) end defp base_email do new_email |&gt; from(&quot;Rob Ot&lt;robot@changelog.com&gt;&quot;) |&gt; put_header(&quot;Reply-To&quot;, &quot;editors@changelog.com&quot;) # This will use the &quot;email.html.eex&quot; file as a layout when rendering html emails. # Plain text emails will not use a layout unless you use `put_text_layout` |&gt; put_html_layout({MyAppWeb.LayoutView, &quot;email.html&quot;}) end end # my_app_web/views/email_view.ex defmodule MyAppWeb.EmailView do use MyAppWeb, :view end # my_app_web/templates/layout/email.html.eex &lt;html&gt; &lt;head&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;&lt;%= static_url(MyApp.Endpoint, &quot;/css/email.css&quot;) %&gt;&quot;&gt; &lt;/head&gt; &lt;body&gt; &lt;%= render @view_module, @view_template, assigns %&gt; &lt;/body&gt; &lt;/html&gt; # my_app_web/templates/email/sign_in.html.eex &lt;p&gt;&lt;%= link &quot;Sign In&quot;, to: sign_in_url(MyApp.Endpoint, :create, @person) %&gt;&lt;/p&gt; # my_app_web/templates/email/sign_in.text.eex # This will not be rendered within a layout because `put_text_layout` was not used. Sign In: &lt;%= sign_in_url(MyApp.Endpoint, :create, @person) %&gt;","ref":"Bamboo.Phoenix.html","title":"Bamboo.Phoenix","type":"module"},{"doc":"Sets an assign for the email. These will be available when rendering the email","ref":"Bamboo.Phoenix.html#assign/3","title":"Bamboo.Phoenix.assign/3","type":"function"},{"doc":"Sets the layout when rendering HTML templates.Exampledef html_email_layout do new_email # Will use MyAppWeb.LayoutView with email.html template when rendering html emails |&gt; put_html_layout({MyAppWeb.LayoutView, &quot;email.html&quot;}) end","ref":"Bamboo.Phoenix.html#put_html_layout/2","title":"Bamboo.Phoenix.put_html_layout/2","type":"function"},{"doc":"Sets the layout for rendering plain text and HTML templates.Exampledef text_and_html_email_layout do new_email # Will use MyAppWeb.LayoutView with the email.html template for html emails # and MyAppWeb.LayoutView with the email.text template for text emails |&gt; put_layout({MyAppWeb.LayoutView, :email}) end","ref":"Bamboo.Phoenix.html#put_layout/2","title":"Bamboo.Phoenix.put_layout/2","type":"function"},{"doc":"Sets the layout when rendering plain text templates.Exampledef text_email_layout do new_email # Will use MyAppWeb.LayoutView with email.text template when rendering text emails |&gt; put_text_layout({MyAppWeb.LayoutView, &quot;email.text&quot;}) end","ref":"Bamboo.Phoenix.html#put_text_layout/2","title":"Bamboo.Phoenix.put_text_layout/2","type":"function"},{"doc":"Render a Phoenix template and set the body on the email.Pass an atom as the template name to render HTML and plain text emails, e.g. :welcome_email. Use a string if you only want to render one type, e.g. &quot;welcome_email.text&quot; or &quot;welcome_email.html&quot;. Scroll to the top for more examples.","ref":"Bamboo.Phoenix.html#render/3","title":"Bamboo.Phoenix.render/3","type":"function"},{"doc":"Sends email using SendGrid's JSON API.Use this adapter to send emails through SendGrid's API. Requires that an API key is set in the config.If you would like to add a replyto header to your email, then simply pass it in using the header property or put_header function like so:put_header(&quot;reply-to&quot;, &quot;foo@bar.com&quot;)To set arbitrary email headers, set them in the headers property of the Bamboo.Email struct. Note that some header names are reserved for use by Sendgrid. See here for full list.Example config# In config/config.exs, or config.prod.exs, etc. config :my_app, MyApp.Mailer, adapter: Bamboo.SendGridAdapter, api_key: &quot;my_api_key&quot;, # or {:system, &quot;SENDGRID_API_KEY&quot;}, # or {ModuleName, :method_name, []} hackney_opts: [ recv_timeout: :timer.minutes(1) ] # To enable sandbox mode (e.g. in development or staging environments), # in config/dev.exs or config/prod.exs etc config :my_app, MyApp.Mailer, sandbox: true # Define a Mailer. Maybe in lib/my_app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app end","ref":"Bamboo.SendGridAdapter.html","title":"Bamboo.SendGridAdapter","type":"module"},{"doc":"Callback implementation for Bamboo.Adapter.deliver/2.","ref":"Bamboo.SendGridAdapter.html#deliver/2","title":"Bamboo.SendGridAdapter.deliver/2","type":"function"},{"doc":"Functions for using features specific to Sendgrid.Exampleemail |&gt; with_template(&quot;80509523-83de-42b6-a2bf-54b7513bd2aa&quot;) |&gt; substitute(&quot;%name%&quot;, &quot;Jon Snow&quot;) |&gt; substitute(&quot;%location%&quot;, &quot;Westeros&quot;)","ref":"Bamboo.SendGridHelper.html","title":"Bamboo.SendGridHelper","type":"module"},{"doc":"Add a property to the list of dynamic template data in the SendGrid template. This will be added to the request as: &quot;personalizations&quot;:[ { &quot;to&quot;:[ { &quot;email&quot;:&quot;example@sendgrid.net&quot; } ], &quot;dynamic_template_data&quot;:{ &quot;total&quot;:&quot;$ 239.85&quot;, } } ],The tag can be of any type since SendGrid allows you to use Handlebars in its templatesExampleemail |&gt; add_dynamic_field(&quot;name&quot;, &quot;Jon Snow&quot;)","ref":"Bamboo.SendGridHelper.html#add_dynamic_field/3","title":"Bamboo.SendGridHelper.add_dynamic_field/3","type":"function"},{"doc":"Add SendGrid personalizationsEach personalization can have the following fields: to, cc, bcc, subject, headers, substitutions, custom_args, or send_at.Settings from the top level of the email (e.g., Email |&gt; with_send_at) will not be applied to each personalization. If you want multiple personalizations with common properties, it is recommended to generate the list from a common base value and simply do not set the corresponding top-level fields.Example: base_personalization = %{bcc: [%{&quot;email&quot; =&gt; &quot;bcc@bar.com&quot;, &quot;name&quot; =&gt; &quot;BCC&quot;}], subject: &quot;Here is your email&quot; } personalizations =Enum.map( [ %{to: &quot;one@test.com&quot;}, %{to: &quot;two@test.com&quot;, send_at: 1_580_485_560} ], &amp;Map.merge(base_personalization, &amp;1) ) email =new_email() |&gt; Email.put_header(&quot;Reply-To&quot;, &quot;reply@foo.com&quot;) |&gt; Bamboo.SendGridHelper.add_personalizations(personalizations)","ref":"Bamboo.SendGridHelper.html#add_personalizations/2","title":"Bamboo.SendGridHelper.add_personalizations/2","type":"function"},{"doc":"Add a tag to the list of substitutions in the SendGrid template.The tag must be a String.t due to SendGrid using special characters to wrap tags in the template.Exampleemail |&gt; substitute(&quot;%name%&quot;, &quot;Jon Snow&quot;)","ref":"Bamboo.SendGridHelper.html#substitute/3","title":"Bamboo.SendGridHelper.substitute/3","type":"function"},{"doc":"An integer id for an ASM (Advanced Suppression Manager) group that this email should belong to. This can be used to let recipients unsubscribe from only a certain type of communication.Exampleemail |&gt; with_asm_group_id(1234)","ref":"Bamboo.SendGridHelper.html#with_asm_group_id/2","title":"Bamboo.SendGridHelper.with_asm_group_id/2","type":"function"},{"doc":"A boolean setting to instruct SendGrid to bypass list management for this email. If enabled, SendGrid will ignore any email supression (such as unsubscriptions, bounces, spam filters) for this email. This is useful for emails that all users must receive, such as Terms of Service updates, or password resets.Exampleemail |&gt; with_bypass_list_management(true)","ref":"Bamboo.SendGridHelper.html#with_bypass_list_management/2","title":"Bamboo.SendGridHelper.with_bypass_list_management/2","type":"function"},{"doc":"An array of category names for this email. A maximum of 10 categories can be assigned to an email. Duplicate categories will be ignored and only unique entries will be sent.Exampleemail |&gt; with_categories(&quot;campaign-12345&quot;)","ref":"Bamboo.SendGridHelper.html#with_categories/2","title":"Bamboo.SendGridHelper.with_categories/2","type":"function"},{"doc":"Instruct SendGrid to enable or disable Google Analytics tracking, and optionally set the UTM parameters for it. This is useful if you need to control UTM tracking parameters on an individual email basis.Exampleemail |&gt; with_google_analytics(true, %{utm_source: &quot;email&quot;, utm_campaign: &quot;campaign&quot;}) email |&gt; with_google_analytics(false)","ref":"Bamboo.SendGridHelper.html#with_google_analytics/3","title":"Bamboo.SendGridHelper.with_google_analytics/3","type":"function"},{"doc":"Specify the ip pool name.Exampleemail |&gt; with_ip_pool_name(&quot;my-ip-pool-name&quot;)","ref":"Bamboo.SendGridHelper.html#with_ip_pool_name/2","title":"Bamboo.SendGridHelper.with_ip_pool_name/2","type":"function"},{"doc":"Schedule a time for SendGrid to deliver the email.Note that if the time is in the past, SendGrid will immediately deliver the email.Example{:ok, delivery_time, _} = DateTime.from_iso8601(&quot;2020-01-01T00:00:00Z&quot;) email |&gt; with_send_at(delivery_time)","ref":"Bamboo.SendGridHelper.html#with_send_at/2","title":"Bamboo.SendGridHelper.with_send_at/2","type":"function"},{"doc":"Specify the template for SendGrid to use for the context of the substitution tags.Exampleemail |&gt; with_template(&quot;80509523-83de-42b6-a2bf-54b7513bd2aa&quot;)","ref":"Bamboo.SendGridHelper.html#with_template/2","title":"Bamboo.SendGridHelper.with_template/2","type":"function"},{"doc":"Used for storing and retrieving sent emails when used with Bamboo.LocalAdapter.When emails are sent with the Bamboo.LocalAdapter, they are stored in Bamboo.SentEmail. Use the functions in this module to store and retrieve the emails.Remember to start the Bamboo app by adding it to the app list in mix.exs or starting it with Application.ensure_all_started(:bamboo)","ref":"Bamboo.SentEmail.html","title":"Bamboo.SentEmail","type":"module"},{"doc":"Returns a list of all sent emails","ref":"Bamboo.SentEmail.html#all/0","title":"Bamboo.SentEmail.all/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Bamboo.SentEmail.html#child_spec/1","title":"Bamboo.SentEmail.child_spec/1","type":"function"},{"doc":"Gets an email by id. Returns nil if it can't find a matching email.","ref":"Bamboo.SentEmail.html#get/1","title":"Bamboo.SentEmail.get/1","type":"function"},{"doc":"Gets an email by id. Raises if it can't find one.","ref":"Bamboo.SentEmail.html#get!/1","title":"Bamboo.SentEmail.get!/1","type":"function"},{"doc":"Gets the email's id.The email must be an email that was sent with Bamboo.LocalAdapter or added via Bamboo.SentEmail.push/1, otherwise the id will not have been set.","ref":"Bamboo.SentEmail.html#get_id/1","title":"Bamboo.SentEmail.get_id/1","type":"function"},{"doc":"Returns exactly one sent email. Raises if none, or more than one are foundRaises NoDeliveriesError if there are no emails. Raises DeliveriesError if there are 2 or more emails.","ref":"Bamboo.SentEmail.html#one/0","title":"Bamboo.SentEmail.one/0","type":"function"},{"doc":"Adds an email to the list of sent emails.Adds an email to the beginning of the sent emails list. Also gives the email an id that can be fetched with Bamboo.SentEmail.get_id/1.","ref":"Bamboo.SentEmail.html#push/1","title":"Bamboo.SentEmail.push/1","type":"function"},{"doc":"Clears all sent emails","ref":"Bamboo.SentEmail.html#reset/0","title":"Bamboo.SentEmail.reset/0","type":"function"},{"doc":"Starts the SentEmail Agent","ref":"Bamboo.SentEmail.html#start_link/1","title":"Bamboo.SentEmail.start_link/1","type":"function"},{"doc":"A plug that exposes delivered emails over a JSON API.This is useful for an integration test runner that doesn't have access to the Bamboo.Test helpers, but needs to be able to assert that emails have been delivered.You must use the Bamboo.LocalAdapter or no emails will be available.Using with Plug or Phoenix# Make sure you are using Bamboo.LocalAdapter in your config config :my_app, MyApp.Mailer, adapter: Bamboo.LocalAdapter # In your Router defmodule MyApp.Router do use Phoenix.Router # or use Plug.Router if you&#39;re not using Phoenix if Mix.env == :e2e do # If using Phoenix forward &quot;/sent_emails_api&quot;, Bamboo.SentEmailApiPlug # If using Plug.Router, make sure to add the `to` forward &quot;/sent_emails_api&quot;, to: Bamboo.SentEmailApiPlug end endAPI endpointsThere are two endpoints:GET /emails.json exposes the list of sent emailsPOST /reset.json resets the sent emails back to an empty listUsually, you would POST to /reset.json at the beginning of a test run, and GET from /emails.json as you need to during an integration test to make assertions. The details of how you make assertions is left up to your integration test runner.Email response JSONSent emails are returned in the following format:{ &quot;to&quot;: [[null, &quot;to@example.com&quot;], [&quot;Alice&quot;, &quot;alice@example.com&quot;]], &quot;text_body&quot;: &quot;hello world&quot;, &quot;subject&quot;: &quot;This is a test email&quot;, &quot;html_body&quot;: &quot;&lt;p&gt;hello world&lt;/p&gt;&quot;, &quot;headers&quot;: {}, &quot;from&quot;: [null, &quot;from@example.com&quot;], &quot;cc&quot;: [[null, &quot;cc@example.com&quot;]], &quot;bcc&quot;: [[&quot;Bob&quot;, &quot;bob@example.com&quot;]], &quot;attachments&quot;: [] }Email addresses are returned in array pairs, with the first element as the name, and the second as the email address. The first element can be null if the address didn't specify a name. The to, cc and bcc fields are returned as arrays of these pairs.","ref":"Bamboo.SentEmailApiPlug.html","title":"Bamboo.SentEmailApiPlug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Bamboo.SentEmailApiPlug.html#call/2","title":"Bamboo.SentEmailApiPlug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Bamboo.SentEmailApiPlug.html#init/1","title":"Bamboo.SentEmailApiPlug.init/1","type":"function"},{"doc":"A plug that can be used in your router to see delivered emails.This plug allows you to view all delivered emails. To see emails you must use the Bamboo.LocalAdapter.Using with Plug or Phoenix# Make sure you are using Bamboo.LocalAdapter in your config config :my_app, MyApp.Mailer, adapter: Bamboo.LocalAdapter # In your Router defmodule MyApp.Router do use Phoenix.Router # or use Plug.Router if you&#39;re not using Phoenix if Mix.env == :dev do # If using Phoenix forward &quot;/sent_emails&quot;, Bamboo.SentEmailViewerPlug # If using Plug.Router, make sure to add the `to` forward &quot;/sent_emails&quot;, to: Bamboo.SentEmailViewerPlug end endNow if you visit your app at /sent_emails you will see a list of delivered emails.","ref":"Bamboo.SentEmailViewerPlug.html","title":"Bamboo.SentEmailViewerPlug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Bamboo.SentEmailViewerPlug.html#call/2","title":"Bamboo.SentEmailViewerPlug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Bamboo.SentEmailViewerPlug.html#init/1","title":"Bamboo.SentEmailViewerPlug.init/1","type":"function"},{"doc":"Default strategy. Sends an email in the background using Task.Supervisor.This is the default strategy when calling deliver_later because it is the simplest to get started with. This strategy uses a Task.Supervisor to monitor the delivery. Deliveries that fail will raise, but will not be retried, and will not bring down the calling process.Why use it?Sending emails can often take time and may fail. If you are sending email during a web request (for instance, sending a welcome email), you probably don't want to make your users wait the extra time for the welcome email to send. Instead you can use deliver_later/1 and it will be delivered in the background so web requests remain snappy.","ref":"Bamboo.TaskSupervisorStrategy.html","title":"Bamboo.TaskSupervisorStrategy","type":"module"},{"doc":"","ref":"Bamboo.TaskSupervisorStrategy.html#supervisor_name/0","title":"Bamboo.TaskSupervisorStrategy.supervisor_name/0","type":"function"},{"doc":"Render emails with layouts, view modules, and templates.This module allows rendering emails with layouts and views. Pass an atom (e.g. :welcome_email) as the template name to render both HTML and plain text emails. Use a string if you only want to render one type, e.g. &quot;welcome_email.text&quot; or &quot;welcome_email.html&quot;.ExamplesSet the text and HTML layout for an email.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email do new_email() |&gt; put_text_layout({MyApp.Email.LayoutView, &quot;email.text&quot;}) |&gt; put_html_layout({MyApp.Email.LayoutView, &quot;email.html&quot;}) |&gt; render(:welcome) # Pass atom to render html AND plain text templates end endYou can optionally pass the html and text layouts when calling use Bamboo.Templatedefmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView text_layout: {MyApp.Email.LayoutView, &quot;email.text&quot;}, html_layout: {MyApp.Email.LayoutView, &quot;email.html&quot;} def welcome_email do new_email() |&gt; render(:welcome) # Pass atom to render html AND plain text templates end endSet both the text and HTML layout at the same time for an email.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email do new_email() |&gt; put_layout({MyApp.Email.LayoutView, :email}) |&gt; render(:welcome) end endRender both text and html emails without layouts.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email do new_email() |&gt; render(:welcome) end endMake assigns available to a template.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email(user) do new_email() |&gt; assign(:user, user) |&gt; render(:welcome) end endMake assigns available to a template during render call.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email(user) do new_email() |&gt; render(:welcome, user: user) end endRender an email by passing the template string to render.defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def html_email do new_email() |&gt; render(&quot;html_email.html&quot;) end def text_email do new_email |&gt; render(&quot;text_email.text&quot;) end endHTML Layout Example# lib/my_app/email.ex defmodule MyApp.Email do use Bamboo.Template, view: MyApp.Email.AccountView def welcome_email(person) do base_email() |&gt; to(person) |&gt; subject(&quot;Welcome to MyApp&quot;) |&gt; assign(:person, person) |&gt; render(:welcome_email) end defp base_email do new_email() |&gt; from(&quot;Rob Ot&lt;robot@changelog.com&gt;&quot;) |&gt; put_header(&quot;Reply-To&quot;, &quot;editors@changelog.com&quot;) # This will use the &quot;email.html.eex&quot; file as a layout when rendering html emails. # Plain text emails will not use a layout unless you use `put_text_layout` |&gt; put_html_layout({MyApp.Email.LayoutView, &quot;email.html&quot;}) end end # lib/my_app/email/views/layout_view.ex defmodule MyApp.Email.LayoutView do use Bamboo.View, path: &quot;lib/my_app/email/templates/layout&quot; end # lib/my_app/email/templates/layout/email.html.eex &lt;html&gt; &lt;body&gt; &lt;%= @inner_content %&gt; &lt;/body&gt; &lt;/html&gt; # lib/my_app/email/views/account_view.ex defmodule MyApp.Email.AccountView do use Bamboo.View, path: &quot;lib/my_app/email/templates/account&quot; end # lib/my_app/email/templates/account/welcome_email.html.eex # This will be rendered within a layout because `put_html_layout` was used. &lt;p&gt;Welcome &lt;%= @person.name %&gt;&lt;/p&gt; # lib/my_app/email/templates/account/welcome_email.text.eex # This will not be rendered within a layout because `put_text_layout` was not used. Welcome &lt;%= @person.name %&gt;","ref":"Bamboo.Template.html","title":"Bamboo.Template","type":"module"},{"doc":"Sets an assign for the email. These will be available when rendering the emailExamplenew_email() # assigns user to be accessed as `@user` in template |&gt; assign(:user, user) |&gt; render(:template_name)","ref":"Bamboo.Template.html#assign/3","title":"Bamboo.Template.assign/3","type":"function"},{"doc":"Sets the layout when rendering HTML templates.Exampledef html_email_layout do new_email # Will use the email.html template of MyApp.LayoutView when rendering html emails |&gt; put_html_layout({MyApp.LayoutView, &quot;email.html&quot;}) end","ref":"Bamboo.Template.html#put_html_layout/2","title":"Bamboo.Template.put_html_layout/2","type":"function"},{"doc":"Sets the layout for rendering plain text and HTML templates.Exampledef text_and_html_email_layout do new_email # Will use email.html and email.text templates of MyApp.LayoutView # when rendering HTML and text emails |&gt; put_layout({MyAppWeb.LayoutView, :email}) end","ref":"Bamboo.Template.html#put_layout/2","title":"Bamboo.Template.put_layout/2","type":"function"},{"doc":"Sets the layout when rendering plain text templates.Exampledef text_email_layout do new_email # Will use the email.text template of MyApp.LayoutView when rendering text emails |&gt; put_text_layout({MyApp.LayoutView, &quot;email.text&quot;}) end","ref":"Bamboo.Template.html#put_text_layout/2","title":"Bamboo.Template.put_text_layout/2","type":"function"},{"doc":"Overrides the view for rendering templatesExampledefmodule MyApp.Email do use Bamboo.Template, view: MyApp.EmailView def different_view_template do new_email # Will use welcome.html template of MyApp.AccountView |&gt; put_view(MyApp.AccountView) |&gt; render(&quot;welcome.html&quot;) end end","ref":"Bamboo.Template.html#put_view/2","title":"Bamboo.Template.put_view/2","type":"function"},{"doc":"Render a template and set the body on the email.Pass an atom as the template name to render HTML and plain text emails, e.g. :welcome_email. Use a string if you only want to render one type, e.g. &quot;welcome_email.text&quot; or &quot;welcome_email.html&quot;.You can also optionally pass assigns.Example# renders both HTML and text emails new_email() |&gt; render(:template_name) # renders HTML template new_email() |&gt; render(&quot;template_name.html&quot;) # renders text template new_email() |&gt; render(&quot;template_name.text&quot;) # renders with assigns new_email() |&gt; render(:template_name, user: user)","ref":"Bamboo.Template.html#render/3","title":"Bamboo.Template.render/3","type":"function"},{"doc":"Helpers for testing email delivery.Use these helpers with Bamboo.TestAdapter to test email delivery. Typically you'll want to unit test emails first. Then, in integration tests, use helpers from this module to test whether that email was delivered.Note on sending from other processesIf you are sending emails from another process (for example, from inside a Task or GenServer) you may need to use shared mode when using Bamboo.Test. See the docs __using__/1 for an example.For most scenarios you will not need shared mode.In your config# Typically in config/test.exs config :my_app, MyApp.Mailer, adapter: Bamboo.TestAdapterUnit testYou don't need any special functions to unit test emails.defmodule MyApp.EmailTest do use ExUnit.Case test &quot;welcome email&quot; do user = %User{name: &quot;John&quot;, email: &quot;person@example.com&quot;} email = MyApp.Email.welcome_email(user) assert email.to == user assert email.subject == &quot;This is your welcome email&quot; assert email.html_body =~ &quot;Welcome to the app&quot; end endIntegration testdefmodule MyApp.Email do import Bamboo.Email def welcome_email(user) do new_email( from: &quot;me@app.com&quot;, to: user, subject: &quot;Welcome!&quot;, text_body: &quot;Welcome to the app&quot;, html_body: &quot;&lt;strong&gt;Welcome to the app&lt;/strong&gt;&quot; ) end end defmodule MyApp.EmailDeliveryTest do use ExUnit.Case use Bamboo.Test test &quot;sends welcome email&quot; do user = %User{...} email = MyApp.Email.welcome_email(user) email |&gt; MyApp.Mailer.deliver_now # Works with deliver_now and deliver_later assert_delivered_email email end end","ref":"Bamboo.Test.html","title":"Bamboo.Test","type":"module"},{"doc":"Imports Bamboo.Test and Bamboo.Formatter.format_email_address/2Bamboo.Test and the Bamboo.TestAdapter work by sending a message to the current process when an email is delivered. The process mailbox is then checked when using the assertion helpers like assert_delivered_email/1.Sometimes emails don't show up when asserting because you may deliver an email from a different process than the test process. When that happens, turn on shared mode. This will tell Bamboo.TestAdapter to always send to the test process. This means that you cannot use shared mode with async tests.Try to use this version firstuse Bamboo.TestAnd if you are delivering from another process, set shared: trueuse Bamboo.Test, shared: trueCommon scenarios for delivering mail from a different process are when you send from inside of a Task, GenServer, or are running acceptance tests with a headless browser like phantomjs.","ref":"Bamboo.Test.html#__using__/1","title":"Bamboo.Test.__using__/1","type":"macro"},{"doc":"Checks whether an email was delivered.Must be used with the Bamboo.TestAdapter or this will never pass. In case you are delivering from another process, the assertion waits up to 100ms before failing. Typically if an email is successfully delivered the assertion will pass instantly, so test suites will remain fast.Examplesemail = Bamboo.Email.new_email(subject: &quot;something&quot;) email |&gt; MyApp.Mailer.deliver assert_delivered_email(email) # Will pass unsent_email = Bamboo.Email.new_email(subject: &quot;something else&quot;) assert_delivered_email(unsent_email) # Will fail","ref":"Bamboo.Test.html#assert_delivered_email/1","title":"Bamboo.Test.assert_delivered_email/1","type":"macro"},{"doc":"Checks whether an email was delivered matching the given pattern.Must be used with the Bamboo.TestAdapter or this will never pass. This allows the user to use their configured assert_receive_timeout for ExUnit, and also to match any variables in their given pattern for use in further assertions.Examples%{email: user_email, name: user_name} = user MyApp.deliver_welcome_email(user) assert_delivered_email_matches(%{to: [{_, ^user_email}], text_body: text_body}) assert text_body =~ &quot;Welcome to MyApp, \#{user_name}&quot; assert text_body =~ &quot;You can sign up at https://my_app.com/users/\#{user_name}&quot;","ref":"Bamboo.Test.html#assert_delivered_email_matches/1","title":"Bamboo.Test.assert_delivered_email_matches/1","type":"macro"},{"doc":"Check whether an email's params are equal to the ones provided.Must be used with the Bamboo.TestAdapter or this will never pass. In case you are delivering from another process, the assertion waits up to 100ms before failing. Typically if an email is successfully delivered the assertion will pass instantly, so test suites will remain fast.Examplesemail = Bamboo.Email.new_email(subject: &quot;something&quot;) email |&gt; MyApp.Mailer.deliver assert_email_delivered_with(subject: &quot;something&quot;) # Will pass unsent_email = Bamboo.Email.new_email(subject: &quot;something else&quot;) assert_email_delivered_with(subject: &quot;something else&quot;) # Will failThe function will use the Bamboo Formatter when checking email addresses.email = Bamboo.Email.new_email(to: &quot;someone@example.com&quot;) email |&gt; MyApp.Mailer.deliver assert_email_delivered_with(to: &quot;someone@example.com&quot;) # Will passYou can also pass a regex to match portions of an email.Exampleemail = new_email(text_body: &quot;I love coffee&quot;) email |&gt; MyApp.Mailer.deliver assert_email_delivered_with(text_body: ~r/love/) # Will pass assert_email_delivered_with(text_body: ~r/like/) # Will fail","ref":"Bamboo.Test.html#assert_email_delivered_with/1","title":"Bamboo.Test.assert_email_delivered_with/1","type":"macro"},{"doc":"Checks that no emails were sent.If Bamboo.Test is used with shared mode, you must also configure a timeout in your test config.# Set this in your config, typically in config/test.exs config :bamboo, :refute_timeout, 10The value you set is up to you. Lower values will result in faster tests, but may incorrectly pass if an email is delivered after the timeout. Often times 1ms is enough.","ref":"Bamboo.Test.html#assert_no_emails_delivered/0","title":"Bamboo.Test.assert_no_emails_delivered/0","type":"function"},{"doc":"Ensures a particular email was not sentSame as assert_delivered_email/0, except it checks that a particular email was not sent.If Bamboo.Test is used with shared mode, you must also configure a timeout in your test config.# Set this in your config, typically in config/test.exs config :bamboo, :refute_timeout, 10The value you set is up to you. Lower values will result in faster tests, but may incorrectly pass if an email is delivered after the timeout. Often times 1ms is enough.","ref":"Bamboo.Test.html#refute_delivered_email/1","title":"Bamboo.Test.refute_delivered_email/1","type":"function"},{"doc":"Check that no email was sent with the given parametersSimilarly to assert_email_delivered_with, the assertion waits up to 100ms before failing. Note that you need to send the email again if you want to make other assertions after this, as this will receive the {:delivered_email, email} message.ExamplesBamboo.Email.new_email(subject: &quot;something&quot;) |&gt; MyApp.Mailer.deliver refute_email_delivered_with(subject: &quot;something else&quot;) # Will pass email = Bamboo.Email.new_email(subject: &quot;something&quot;) |&gt; MyApp.Mailer.deliver refute_email_delivered_with(subject: ~r/some/) # Will fail","ref":"Bamboo.Test.html#refute_email_delivered_with/1","title":"Bamboo.Test.refute_email_delivered_with/1","type":"macro"},{"doc":"Used for testing email delivery.No emails are sent, instead a message is sent to the current process and can be asserted on with helpers from Bamboo.Test.Example config# Typically done in config/test.exs config :my_app, MyApp.Mailer, adapter: Bamboo.TestAdapter # Define a Mailer. Typically in lib/my_app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app end","ref":"Bamboo.TestAdapter.html","title":"Bamboo.TestAdapter","type":"module"},{"doc":"Callback implementation for Bamboo.Adapter.handle_config/1.","ref":"Bamboo.TestAdapter.html#handle_config/1","title":"Bamboo.TestAdapter.handle_config/1","type":"function"},{"doc":"Compiles and renders templates defined in a given path.Functions defined in the view are available to use in its templates.Exampledefmodule MyApp.EmailView do use Bamboo.View, path: &quot;lib/my_app/email/templates&quot; def app_title do &quot;My Super App&quot; end end # lib/my_app/email_templates/welcome.html &lt;h1&gt;Welcome to &lt;%= app_title() %&gt;&lt;/h1&gt;","ref":"Bamboo.View.html","title":"Bamboo.View","type":"module"},{"doc":"Error used to represent a problem when sending emails through an external email service API.","ref":"Bamboo.ApiError.html","title":"Bamboo.ApiError","type":"exception"},{"doc":"Raises an ApiError with the given message or service_name, response and params.An extra error message can be added using a fourth parameter extra_message.Examplesiex&gt; raise_api_error(&quot;Error message&quot;) ** (Bamboo.ApiError) Error Message iex&gt; raise_api_error(service_name, response, params) ** (Bamboo.ApiError) There was a problem sending the email through the &lt;service_name&gt; API. Here is the response: &quot;&lt;response&gt;&quot; Here are the params we sent: &quot;&lt;params&gt;&quot; iex&gt; raise_api_error(service_name, response, params, extra_message) ** (Bamboo.ApiError) There was a problem sending the email through the &lt;service_name&gt; API. Here is the response: &quot;&lt;response&gt;&quot; Here are the params we sent: &quot;&lt;params&gt;&quot; &lt;extra_message&gt;","ref":"Bamboo.ApiError.html#raise_api_error/1","title":"Bamboo.ApiError.raise_api_error/1","type":"function"},{"doc":"","ref":"Bamboo.ApiError.html#raise_api_error/4","title":"Bamboo.ApiError.raise_api_error/4","type":"function"},{"doc":"","ref":"Bamboo.EmptyFromAddressError.html","title":"Bamboo.EmptyFromAddressError","type":"exception"},{"doc":"","ref":"Bamboo.NilRecipientsError.html","title":"Bamboo.NilRecipientsError","type":"exception"},{"doc":"","ref":"Bamboo.SentEmail.DeliveriesError.html","title":"Bamboo.SentEmail.DeliveriesError","type":"exception"},{"doc":"","ref":"Bamboo.SentEmail.NoDeliveriesError.html","title":"Bamboo.SentEmail.NoDeliveriesError","type":"exception"},{"doc":"Exception raised when a template cannot be found.","ref":"Bamboo.View.UndefinedTemplateError.html","title":"Bamboo.View.UndefinedTemplateError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Bamboo.View.UndefinedTemplateError.html#message/1","title":"Bamboo.View.UndefinedTemplateError.message/1","type":"function"},{"doc":"&lt;img src=&quot;https://user-images.githubusercontent.com/22394/39895001-b13a9c9a-5476-11e8-9c58-f5fc5f09b697.png&quot; alt=&quot;bamboo&quot; height=&quot;120px&quot;&gt;Bamboo This README follows master, which may not be the currently published version! Use the docs for the published version of Bamboo.Bamboo is part of the thoughtbot Elixir family of projects.Flexible and easy to use email for Elixir.Built-in support for popular mail delivery services. Bamboo ships with adapters for several popular mail delivery services, including Mandrill, Mailgun, and SendGrid. It's also quite easy to write your own delivery adapter if your platform isn't yet supported.Deliver emails in the background. Most of the time you don't want or need to wait for the email to send. Bamboo makes it easy with Mailer.deliver_later.A functional approach to mail delivery. Emails are created, manipulated, and sent using plain functions. This makes composition a breeze and fits naturally into your existing Elixir app.Unit test with ease. Bamboo separates email creation and email delivery allowing you to test by asserting against email fields without the need for special functions.Dead-simple integration tests. Bamboo provides helper functions to make integration testing easy and robust.View sent emails during development. Bamboo provides a plug you can use in your router to view sent emails.Integrate with Phoenix out of the box. Use Phoenix views and layouts to make rendering email easy.See the docs for the most up to date information.We designed Bamboo to be simple and powerful. If you run into anything that is less than exceptional, or you just need some help, please open an issue.","ref":"readme.html","title":"Bamboo","type":"extras"},{"doc":"To install Bamboo, add it to your list of dependencies in mix.exs.def deps do [{:bamboo, &quot;~&gt; 1.7.0&quot;}] endYou may also use the latest code available from master instead of a published version in hex:def deps do [{:bamboo, github: &quot;thoughtbot/bamboo&quot;}] endOnce you've added Bamboo to your list, update your dependencies by running:$ mix deps.getIf you are using Elixir &lt; 1.4, also ensure Bamboo is started alongside your application:def application do [applications: [:bamboo]] end","ref":"readme.html#installation","title":"Bamboo - Installation","type":"extras"},{"doc":"Bamboo separates the tasks of email creation and email sending. To use Bamboo, you'll need to define one or more email modules (email creation), define a mailer module (email sending), and provide some configuration.To create emails, define an email module within your application.# some/path/within/your/app/email.ex defmodule MyApp.Email do import Bamboo.Email def welcome_email do new_email( to: &quot;john@example.com&quot;, from: &quot;support@myapp.com&quot;, subject: &quot;Welcome to the app.&quot;, html_body: &quot;&lt;strong&gt;Thanks for joining!&lt;/strong&gt;&quot;, text_body: &quot;Thanks for joining!&quot; ) end endIn addition to the keyword syntax above you can also compose emails using pipes.To send emails, define a mailer module for your application that uses Bamboo's mailer.# some/path/within/your/app/mailer.ex defmodule MyApp.Mailer do use Bamboo.Mailer, otp_app: :my_app endYour configuration will need to know your otp application, your mailer module, the adapter you are using, and any additional configuration required by the adapter itself.# config/config.exs config :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapter, api_key: &quot;my_api_key&quot;Bamboo uses Hackney for making requests. If you want to pass options to Hackney directly, such as controlling timeouts, you can use the hackney_opts key:# config/config.exs config :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapter, api_key: &quot;my_api_key&quot;, hackney_opts: [ recv_timeout: :timer.minutes(1), connect_timeout: :timer.minutes(1) ]Other adapter-specific configuration may be required. Be sure to check the adapter's docs.Now that you have configured Bamboo and defined your modules, you can deliver email in fitting places within your application.defmodule MyApp.SomeControllerPerhaps do def send_welcome_email do Email.welcome_email() # Create your email |&gt; Mailer.deliver_now() # Send your email end endYour application is now set up to send email with Bamboo! :tada:","ref":"readme.html#getting-started","title":"Bamboo - Getting Started","type":"extras"},{"doc":"An adapter is a set of instructions for how to communicate with a specific email delivery service. Bamboo ships with support for several popular services, there are others made available by the community, or you can use other services by writing a custom adapter.To use an adapter, declare it in the configuration for your mailer:# config/config.exs config :my_app, MyApp.Mailer, adapter: Bamboo.MandrillAdapterBamboo provides adapters for use in development and testing. To use these adapters, declare them in the environment configuration.The local adapter stores emails in memory that can be viewed during development. Declare its use in your dev environment.# config/dev.exs config :my_app, MyApp.Mailer, adapter: Bamboo.LocalAdapterThe test adapter sends emails to your running process allowing you to test mail delivery without emails being sent externally. Declare its use in your test environment.# config/test.exs config :my_app, MyApp.Mailer, adapter: Bamboo.TestAdapterYou can create new adapters for any environment by implementing the Bamboo.Adapter behaviour.","ref":"readme.html#using-adapters","title":"Bamboo - Using Adapters","type":"extras"},{"doc":"Often times you don't want to send email right away because it can block process completion (e.g. a web request in Phoenix). Bamboo provides a deliver_later function on your mailers to send emails in the background. It also provides a Bamboo.DeliverLaterStrategy behaviour that you can implement to tailor your background email sending.By default, deliver_lateruses Bamboo.TaskSupervisorStrategy. This strategy sends the email right away, but does so in the background without linking to the calling process, so errors in the mailer won't bring down your app.You can also create custom strategies by implementing the Bamboo.DeliverLaterStrategy behaviour. For example, you could create strategies for adding emails to a background processing queue such as exq or toniq.","ref":"readme.html#delivering-emails-in-the-background","title":"Bamboo - Delivering Emails in the Background","type":"extras"},{"doc":"In addition to creating emails with keyword lists you can use pipe syntax to compose emails. This is particularly useful for providing defaults (e.g. from address, default layout, etc.)defmodule MyApp.Email do import Bamboo.Email import Bamboo.Phoenix def welcome_email do base_email() # Build your default email then customize for welcome |&gt; to(&quot;foo@bar.com&quot;) |&gt; subject(&quot;Welcome!!!&quot;) |&gt; put_header(&quot;Reply-To&quot;, &quot;someone@example.com&quot;) |&gt; html_body(&quot;&lt;strong&gt;Welcome&lt;/strong&gt;&quot;) |&gt; text_body(&quot;Welcome&quot;) end defp base_email do new_email() |&gt; from(&quot;myapp@example.com&quot;) # Set a default from |&gt; put_html_layout({MyApp.LayoutView, &quot;email.html&quot;}) # Set default layout |&gt; put_text_layout({MyApp.LayoutView, &quot;email.text&quot;}) # Set default text layout end end","ref":"readme.html#composing-with-pipes","title":"Bamboo - Composing with Pipes","type":"extras"},{"doc":"The from, to, cc and bcc addresses can be a string or a 2 element tuple. What happens if you try to send to a list of MyApp.Users? Transforming your data structure each time you send an email would be a pain.# This stinks. Do you want to do this every time you create a new email? users = for user &lt;- users do {user.name, user.email} end new_email(to: users)Bamboo alleviates this pain by providing the Bamboo.Formatter protocol. By implementing the protocol for your data structure once, you can pass that struct directly to Bamboo anywhere it expects an address. See the Bamboo.Email and Bamboo.Formatter docs for more information and examples.","ref":"readme.html#handling-recipients","title":"Bamboo - Handling Recipients","type":"extras"},{"doc":"Phoenix is not required to use Bamboo. However, if you do use Phoenix, you can use Phoenix views and layouts with Bamboo. See Bamboo.Phoenix.","ref":"readme.html#using-phoenix-views-and-layouts","title":"Bamboo - Using Phoenix Views and Layouts","type":"extras"},{"doc":"Bamboo comes with a handy plug for viewing emails sent in development. Now you don't have to look at the logs to get password resets, confirmation links, etc. Just open up the sent email viewer and click the link.See Bamboo.SentEmailViewerPlug.Here is what it looks like:","ref":"readme.html#viewing-sent-emails","title":"Bamboo - Viewing Sent Emails","type":"extras"},{"doc":"Mandrill offers extra features on top of regular SMTP email like tagging, merge vars, templates, and scheduling emails to send in the future. See Bamboo.MandrillHelper.","ref":"readme.html#mandrill-specific-functionality-tags-merge-vars-templates-etc","title":"Bamboo - Mandrill Specific Functionality (tags, merge vars, templates, etc.)","type":"extras"},{"doc":"SendGrid offers extra features on top of regular SMTP email like transactional templates with substitution tags. See Bamboo.SendGridHelper.","ref":"readme.html#sendgrid-specific-functionality-templates-substitution-tags-scheduled-delivery-etc","title":"Bamboo - SendGrid Specific Functionality (templates, substitution tags, scheduled delivery, etc.)","type":"extras"},{"doc":"Bamboo comes with JSON support out of the box via the Jason library. To use it, add :jason to your dependencies:{:jason, &quot;~&gt; 1.0&quot;}You can customize it to use another library via the :json_library configuration:config :bamboo, :json_library, SomeOtherLib","ref":"readme.html#json-support","title":"Bamboo - JSON support","type":"extras"},{"doc":"Bamboo separates email creation and email sending. Test email creation by asserting against the email struct created by your functions. For example, assuming your welcome email accepts a user recipient, provides the correct from address, and provides specific text, you might test like this:defmodule MyApp.EmailTest do use ExUnit.Case test &quot;welcome email&quot; do user = {&quot;Ralph&quot;, &quot;ralph@example.com&quot;} email = MyApp.Email.welcome_email(user) assert email.to == user assert email.from == &quot;welcome@myapp.com&quot; assert email.html_body =~ &quot;&lt;p&gt;Thanks for joining&lt;/p&gt;&quot; assert email.text_body =~ &quot;Thanks for joining&quot; end endTest email sending in integration tests by using the Bamboo.TestAdapter along with Bamboo.Test. For example, assuming during the registration process of your app an email is sent to the user welcoming them to the application, you might test this feature like this:defmodule MyApp.RegistrationTest do use ExUnit.Case use Bamboo.Test # Remember to use the `Bamboo.TestAdapter` in your test config test &quot;after registering, the user gets a welcome email&quot; do user = new_user() expected_email = MyApp.Email.welcome_email(user.email) MyApp.Registration.create(user) assert_delivered_email expected_email end defp new_user do # Build a user appropriate to your application end endSee the documentation for Bamboo.Test for more examples and additional helper functions.","ref":"readme.html#testing","title":"Bamboo - Testing","type":"extras"},{"doc":"Here is a list of adapters that either ship with Bamboo or have been made available by the community. Feel free to open an issue or a PR if you'd like to add a new adapter to the list.Bamboo.LocalAdapter - Ships with Bamboo. Stores email in memory. Great for local development.Bamboo.MailgunAdapter - Ships with Bamboo. Thanks to @princemaple.Bamboo.MandrillAdapter - Ships with Bamboo.Bamboo.SendGridAdapter - Ships with Bamboo.Bamboo.TestAdapter - Ships with Bamboo. Use in your test environment.Bamboo.CampaignMonitorAdapter - See jackmarchant/bamboo_campaign_monitor.Bamboo.ConfigAdapter - See BinaryNoggin/bamboo_config_adapter declare config at runtime.Bamboo.FallbackAdapter - See fuelen/bamboo_fallback. Allows using multiple adapters.Bamboo.GmailAdapter - See parkerduckworth/bamboo_gmail.Bamboo.MailjetAdapter - See moxide/bamboo_mailjet.Bamboo.PostmarkAdapter - See pablo-co/bamboo_postmark.Bamboo.SendcloudAdapter - See linjunpop/bamboo_sendcloud.Bamboo.SesAdapter - See kalys/bamboo_ses.Bamboo.SMTPAdapter - See fewlinesco/bamboo_smtp.Bamboo.SparkPostAdapter - See andrewtimberlake/bamboo_sparkpost.","ref":"readme.html#available-adapters","title":"Bamboo - Available Adapters","type":"extras"},{"doc":"Before opening a pull request, please open an issue first.Once we've decided how to move forward with a pull request:$ git clone https://github.com/thoughtbot/bamboo.git $ cd bamboo $ mix deps.get $ mix test $ mix formatOnce you've made your additions and mix test passes, go ahead and open a PR!We run the test suite as well as formatter checks on CI. Make sure you are using the Elixir version defined in the .tool-versions file to have consistent formatting with what's being run on CI.","ref":"readme.html#contributing","title":"Bamboo - Contributing","type":"extras"},{"doc":"Bamboo is maintained and funded by thoughtbot, inc. The names and logos for thoughtbot are trademarks of thoughtbot, inc.We love open source software, Elixir, and Phoenix. See our other Elixir projects, or hire our Elixir Phoenix development team to design, develop, and grow your product.","ref":"readme.html#about-thoughtbot","title":"Bamboo - About thoughtbot","type":"extras"},{"doc":"Thanks to @mtwilliams for an early version of the SendGridAdapter.","ref":"readme.html#thanks","title":"Bamboo - Thanks!","type":"extras"}]